//
//  NetworkController.h
//  Planarity
//
//  Created by Matthew Crandall on 2/17/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "NetworkServer.h"
#import "PCController.h"
#import "MCPlanarityViewController.h"

@interface NetworkController : NSObject {
	IBOutlet NSWindow *mainWindow;
	IBOutlet NSWindow *networkWindow;
	IBOutlet NSTableView *networkTable;
	IBOutlet NSTextField *ipField;
	IBOutlet NSTextField *nickname;
	IBOutlet NSButton *bonjourConnect;
	IBOutlet NSButton *multiplayerButton;
	IBOutlet NSButton *ipConnectButton;
	IBOutlet MCPlanarityViewController *gameController;
    NSNetServiceBrowser * serviceBrowser;
    NSMutableArray * serviceList;
	
	NetworkServer *server;
	PCController *client;
}

- (void)controlTextDidChange:(NSNotification *)aNotification;
- (void)gameWon:(NSString *)winnerName;
- (void)removeView:(NSView *)view;
- (void)startLevel:(int)level;
- (void)addView:(NSView *)view;
- (void)setChatView:(NSView *)chatView;
- (void)togglePause;
- (void)setConnected;
- (void)disconnected;
- (void)startNetworkGameForLevel:(int)level withDiff:(NSString *)aDiff;
- (void)connectViaBonjour:(id)sender;
- (void)connectViaIP:(id)sender;
- (void)connectViaIPWithString:(NSString *)ipString;
- (void)startServer:(id)sender;
- (void)showNetworkPanel:(id)sender;
- (void) closeNetworkWindow:(id)sender;
- (void)setupConnectedPlayersWithCircles:(NSArray *)circles andEdges:(NSArray *)edges;
- (void)tableViewSelectionDidChange:(NSNotification *)aNotification;

@end
