//
//  PCController.h
//  Planarity
//
//  Created by Matthew Crandall on 2/17/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
@class NetSocket;
@class NetPacket;
@class NetworkController;


@interface PCController : NSObject {
	NetSocket	*_socket;
	NSString	*_nickname;
	NSMutableArray *_connectedPlayers;
	NetworkController *_networkController;
	
	IBOutlet NSTextView *_textChatView;
	IBOutlet NSTextView *_inputTextView;
	IBOutlet NSView *_chatView;
}

- (void)setNetworkController:(NetworkController *)nc;
- (void)setSeed:(unsigned long)seed;
- (void)connectToAddress:(NSString*)inAddress;
- (void)loginWithNickname:(NSString*)inNickname;
- (void)sendChat:(NSAttributedString*)inChat;
- (void)disconnect;
- (void)togglePause;
- (void)startLevel:(int)level;
- (void)gameWon;
- (void)setupConnectedPlayersWithCircles:(NSArray*)circles andEdges:(NSArray *)edges;
- (void)processNewGamePacket:(NetPacket *)inPacket;
- (void)processPacket:(NetPacket*)inPacket;
- (void)processTogglePause:(NetPacket *)inPacket;
- (void)processSeedPacket:(NetPacket *)inPacket;
- (void)processNewClientPacket:(NetPacket*)inPacket;
- (void)processClientDisconnectedPacket:(NetPacket*)inPacket;
- (void)processChatPacket:(NetPacket*)inPacket;
- (void)processGameWon:(NetPacket *)inPacket;
- (NSString *)nickname;
- (void)setNickname:(NSString *)nickname;
- (BOOL)textView:(NSTextView*)inTextView doCommandBySelector:(SEL)inSelector;
- (void)finishedMoveForCircleAtIndex:(unsigned int)index atX:(float)x atY:(float)y;
- (void) processVertexMove:(NetPacket *)inPacket;

@end
